// the main file 

include <player.wdl>;         
include <weapons.wdl>;        
include <doors.wdl>;
include <enemy.wdl>;
include <menu.wdl>;
include <structures.wdl>;     // global variables
include <trigger.wdl>;        // trigger system to activate/deactivate areas
include <events_level1.wdl>;  // special actions for level 1
include <events_level2.wdl>;  // special actions for level 2
include <water.wdl>;
include <dynLight.wdl>;       // handling dynamic lights
include <ShowGameValues.wdl>; // displays a panel of active areas ( triggersystem ), framerate


bmap mousepointer_menu = <mousepointer.tga>;      // mousepointer for menu
bmap crosshair = <crosshair.tga>;                 // for weapons !!!!! 


bmap A6_Logo = <logolite.pcx>;                    // show A6 logo 
string intro_video = <intro_dw.avi>;              // intro video
bmap intro_video_bg_image = <introvideo_bg_image.bmp>;   // panel image for intro video





entity* player;                                   // global player entity




panel pan_A6Logo                                  // panel definition for a6 logo
{
	bmap = A6_Logo;
	pos_x = 0;
	pos_y = 0;
	layer = 11;
	alpha = 100;
	flags = refresh, visible,transparent;	
}

panel pan_introvideo										  // panel definition for intro video
{
	bmap = intro_video_bg_image;
	pos_x = 0;
	pos_y = 0;
	layer = 10;
	alpha = 100;
	flags = visible,transparent;
}


function main
{
	clip_factor = 0.5;
	camera.clip_near = 0;
	camera.clip_far = 2400;
	
	
	level_load(str_level_start);
	
	wait(2);
	
	options_load();                              // loading saved resolution, etc. 
	pausemenu_deactivate();                      // deactivate pausemenu
	
	mainmenu_deactivate();                       // deactivate mainmenu
	
	
	pan_A6Logo.scale_x = (Screen_Size.x+1) / 800;      // scale panel -> resolution dependently
	pan_A6Logo.scale_y = (Screen_Size.y+1) / 600;
	
	pan_introvideo.scale_x = (Screen_Size.x+1) / 800;  // scale panel -> resolution dependently
	pan_introvideo.scale_y = (Screen_Size.y+1) / 600;
	
	sleep(1);
	while(pan_A6Logo.alpha > 0)                        // blend smooth
	{
		pan_A6Logo.alpha -= 5 * time;
		wait(1);
	}
	
	pan_remove(pan_A6Logo);
	
	wait(1);
	media_play(intro_video,null,100);                  // then play intro video
	wait(4);
	while(media_playing(media_handle) ) 
	{
		
		if (key_pressed(28) == on)                      // press return-key to skip intro 
		{
			media_stop(media_handle);
		}
		
		
		wait(1);
	}
	
	
	if (snd_playing(hm_bg_music_handle) == 0)
	{
		hm_bg_music_handle = snd_loop(hm_bg_music,100,0);
	}
	
	while(pan_introvideo.alpha > 0)                    // blend smooth
	{
		pan_introvideo.alpha -= 5 * time;
		wait(1);
	}
	pan_remove(pan_introvideo);
	wait(2);
	
	pausemenu_deactivate();
	mainmenu_activate();
	
	
	wait(2);
	
	
	menu_active = 1;
	
	
	game_init();                                 // weapon handling
	
	mouse_speed_x = mouse_speed_normal_x;        // normal mouse speed ...
	mouse_speed_y = mouse_speed_normal_y;        
	
	while(1)
	{
		InGameFramerate = (1/time)*16;
		
		if (menu_active == 1)                     // menu mode
		{
			wait(1);
			mouse_mode = 2;
			mouse_map = mousepointer_menu;
			mouse_pos.x = pointer.x;
			mouse_pos.y = pointer.y;
			
			
			
			// if you are in the options menu -> new keys are defined in the main loop
			
			if (key_define_Player_MoveForward == 1)   // if you want to change the key
			{
				
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_MoveForward = key_lastpressed;     // new key for player movement forward
				str_for_key(str_key_Player_MoveForward, key_lastpressed);
				key_define_Player_MoveForward = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerForward.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerForward.pos_y = 160 * ( screen_size.y / 600 );
			} 
			
			
			if (key_define_Player_MoveBackward == 1)   // if you want to change the key
			{
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_MoveBackward = key_lastpressed;  // new key for player movement backward
				str_for_key(str_key_Player_MoveBackward, key_lastpressed);
				key_define_Player_MoveBackward = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerBackward.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerBackward.pos_y = 180 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_StepLeft == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_StepLeft = key_lastpressed;   // new key for player movement step left
				str_for_key(str_key_Player_StepLeft, key_lastpressed);
				key_define_Player_StepLeft = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerStepLeft.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerStepLeft.pos_y = 200 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_StepRight == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_StepRight = key_lastpressed;  // new key for player movement step right
				str_for_key(str_key_Player_StepRight, key_lastpressed);
				key_define_Player_StepRight = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerStepRight.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerStepRight.pos_y = 220 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_Jump == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_Jump = key_lastpressed;  // new key for player jump
				str_for_key(str_key_Player_Jump, key_lastpressed);
				key_define_Player_Jump = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerJump.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerJump.pos_y = 240 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_Use == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_Use = key_lastpressed;
				str_for_key(str_key_Player_Use, key_lastpressed);  // new key for player use
				key_define_Player_Use = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerUse.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerUse.pos_y = 260 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_SelectWeapon1 == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_SelectWeapon1 = key_lastpressed;  // new key for player select weapon 1
				str_for_key(str_key_Player_SelectWeapon1, key_lastpressed);
				key_define_Player_SelectWeapon1 = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerSelectWeapon1.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerSelectWeapon1.pos_y = 280 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_SelectWeapon2 == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_SelectWeapon2 = key_lastpressed;  // new key for player select weapon 2
				str_for_key(str_key_Player_SelectWeapon2, key_lastpressed);
				key_define_Player_SelectWeapon2 = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerSelectWeapon2.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerSelectWeapon2.pos_y = 300 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_SelectWeapon3 == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_SelectWeapon3 = key_lastpressed;  // new key for player select weapon 3
				str_for_key(str_key_Player_SelectWeapon3, key_lastpressed);
				key_define_Player_SelectWeapon3 = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerSelectWeapon3.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerSelectWeapon3.pos_y = 320 * ( screen_size.y / 600 );
			}
			
			if (key_define_Player_SelectWeapon4 == 1)   // if you want to change the key
			{
				sleep(0.5);
				while(key_any == 0)
				{
					wait(1);
				}
				key_Player_SelectWeapon4 = key_lastpressed;  // new key for player select weapon 4
				str_for_key(str_key_Player_SelectWeapon4, key_lastpressed);
				key_define_Player_SelectWeapon4 = 0;
				txt_PressKey.pos_x = -2000;
				txt_Key_PlayerSelectWeapon4.pos_x = 500 * ( screen_size.x / 800 );
				txt_Key_PlayerSelectWeapon4.pos_y = 340 * ( screen_size.y / 600 );
			}
			
			
		}
		
		if (menu_active == 0 && player != null)   // gaming mode -> no menu is active 
		{
			mouse_mode = 0;
			mouse_map = crosshair;
			
			if (player.skill4 > 0)  // player's health > 0
			{
			
			player.pan - = mouse_force.x * mouse_speed_x * time;    // mouse_speed -> see structures.wdl
			camera.tilt += mouse_force.y * mouse_speed_y * time;		
			if (camera.tilt < -90) { camera.tilt = -90;} // limit the rotation ... 
			if (camera.tilt > 90) { camera.tilt = 90;}   // ... of players camera
			camera.pan = player.pan;
			camera.x = player.x;
			camera.y = player.y;
			camera.z = player.z + 30; // position of players eyes
			}
		}	
				
		wait(1);
	}
	
	
}


function ESC_handling()                 // 
{
	
	
	if (menu_active == 1) // if menu active
	{
		if (mainmenu_active == 1) // esc-handling if menu is active
		{
			wait(1); 
		}
		
		if (pausemenu_active == 1) // esc-handling if pausemenu is active
		{
			pausemenu_deactivate();
		}
		
		if (optionsmenu_active == 1) // esc-handling if optionsmenu is active
		{
			optionsmenu_deactivate();
		}
	}
	
	if (menu_active == 0) // if no menu is active
	{
		if (!media_playing(media_handle))   // esc-handling during intro video
		{
			pausemenu_activate();
		}
	}
	
}



on_esc = ESC_handling;
on_F10 = null;
on_F3  = null;
on_F5  = null;
on_F6  = null;
on_F7  = null;
on_F11 = null;